import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

public class Calculette extends Applet 
 implements ActionListener {

 /* Maximum de caractres */
 int maxTouches=10;
 
 /* Zone rsultat */
 Label result = new Label("0");
 
 /* Variables */
 String a = "";             /* premire entre */
 double c = 0;              /* rsultat */

 /* drapeaux */
 int num_press = 0;         /* nombre de touches presses */
 boolean op_press = false;  /* opration en cours */
 boolean decimal=false;     /* point dcimal dj crit */
 char last_op = '=';        /* code opration en cours */
 
 /* format dcimal */
 DecimalFormat df;
 
 public void init() {
  DecimalFormatSymbols dfs=new DecimalFormatSymbols();
  dfs.setDecimalSeparator('.');
  // format d'affichage des nombres 
  df=new DecimalFormat("0.######",dfs);
   
  Panel mp = new Panel();
  Panel p;

  result.setBackground(Color.black);
  result.setForeground(Color.green);
  result.setAlignment(Label.RIGHT);
  result.setFont(new Font("Monospace",Font.BOLD,12));
  setLayout(new BorderLayout());
  mp.setLayout(new GridLayout(6,1,2,2));
  add("Center",mp);
  mp.add(result);
  p=new Panel();
  p.setLayout(new GridLayout(1,4,2,2));
  addButton(p,"7");
  addButton(p,"8");
  addButton(p,"9");
  addButton(p,"/");
  mp.add(p);
  p=new Panel();
  p.setLayout(new GridLayout(1,4,2,2));
  addButton(p,"4");
  addButton(p,"5");
  addButton(p,"6");
  addButton(p,"*");
  mp.add(p);
  p=new Panel();
  p.setLayout(new GridLayout(1,4,2,2));
  addButton(p,"1");
  addButton(p,"2");
  addButton(p,"3");
  addButton(p,"-");
  mp.add(p);
  p=new Panel();
  p.setLayout(new GridLayout(1,4,2,2));
  addButton(p,"0");
  addButton(p,".");
  addButton(p,"C");
  addButton(p,"+");
  mp.add(p);
  p=new Panel();
  p.setLayout(new GridLayout(1,1));
  addButton(p,"=");
  mp.add(p);
 }

 void addButton(Panel p, String name) {
  Button b=new Button(name);
  b.addActionListener(this);
  p.add(b);
 }
 
 public Insets getInsets() {
  return new Insets(4,4,4,4);
 }
 
 void affiche(double d) {
  if (Double.isNaN(d)) result.setText("ERREUR");
  else { 
   double t=Math.floor(d*1000000+0.5)/1000000;
   result.setText(df.format(t));
  } 
 }
 
 public void actionPerformed(ActionEvent e) {
  String com=e.getActionCommand();
  switch (com.charAt(0)) {
   case 'C' : 
    a="";
    c=0.0;
    num_press=0;
    op_press=false;
    decimal=false;
    affiche(c);
    break;
   
   case '=' :
    perform_calculation();
    num_press=0;
    op_press=false;
    last_op='=';
    decimal=false;
    affiche(c);
    break;
   
   case '+': case '-': case '*' : case '/':
    perform_calculation();
    affiche(c);
    num_press=0;
    decimal=false;
    last_op=com.charAt(0);
    op_press=true;
    break;
   
   default :
    if (num_press==0) a=""; 
    if (num_press<maxTouches) {
     if ((!decimal) || (decimal && com.charAt(0)!='.')) {
      a=a+com;
      num_press++;
      if (com.charAt(0)=='.') decimal=true;
     }
    } 
    if (a.equals(".")) {
     a="0.";
     num_press++;
    }   
    result.setText(a);
  }
 }
 
 double strToDouble(String S) {
  Double D=new Double(S);
  return D.doubleValue();
 }
 
 public void perform_calculation() {
  if (op_press) {
   switch(last_op) {
    case '+':
     if (!Double.isNaN(c)) c=c+strToDouble(a);
     break;
    case '-':
     if (!Double.isNaN(c)) c=c-strToDouble(a);
     break;
    case '*':
     if (!Double.isNaN(c)) c=c*strToDouble(a);
     break;
    case '/':
     if (!Double.isNaN(c)) {
      if (strToDouble(a)==0) c=Double.NaN;
      else c=c/strToDouble(a);
     } 
     break;
    default:
   }
   op_press=false;
   last_op=' ';
  } 
  else {
   c=strToDouble(result.getText());
  }
 }
 
}

