import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/*
 * Simulation du jeu pierre, ciseaux, feuille.
 * d'aprs
 * Jamie M. Hall, jamihall@mhv.net 12/95
 * 
 * Feel free to re-use any part of this code.
 */

public class Rochambeaux extends Applet 
 implements ActionListener {

  Button rock, paper, scissors;
  Label computer, result, score;
  int sco;
  
  public void init() {
    setFont(new Font("Helvetica", Font.BOLD, 14));
    setBackground(Color.white);
    sco=0;
    
    Panel o = new Panel();
    add(o);

    rock = new Button("Pierre");
    rock.setBackground(Color.orange);
    rock.addActionListener(this);
    o.add(rock);

    paper = new Button("Papier");
    paper.setBackground(Color.cyan);
    paper.addActionListener(this);
    o.add(paper);

    scissors = new Button("Ciseaux");
    scissors.setBackground(Color.magenta);
    scissors.addActionListener(this);
    o.add(scissors);

    computer = new Label("Ordi :               ");
    add(computer);

    result = new Label("               ");
    add(result);

    score = new Label("   "+sco+"   ");
    add(score);

  }

  public void actionPerformed(ActionEvent evt) {
    if (evt.getSource() instanceof Button)
      doRound(evt.getActionCommand());
  }

  void setScoColor() {
   if (sco<0) score.setForeground(Color.red);
   else if (sco>0) score.setForeground(Color.green);
   else score.setForeground(Color.black);
  }
  
  void gagne() {
   result.setText("Gagn!");
   sco++;
   score.setText("   "+sco+"   ");
   setScoColor();
  }
  
  void perd() {
   result.setText("Perdu!");
   sco--;
   score.setText("   "+sco+"   ");
   setScoColor();
  }
  
  public void doRound(String hand) {
    int compThrow, playerThrow;

    compThrow=(int)Math.floor(Math.random()*3);

    if (hand == "Pierre") 
      playerThrow = 0;
    else if (hand == "Papier")
      playerThrow = 1;
    else playerThrow = 2;

    if (compThrow == 0)
      computer.setText("Ordi : Pierre");
    else if (compThrow == 1)
      computer.setText("Ordi : Papier");
    else computer.setText("Ordi : Ciseaux");
       
    if (playerThrow == compThrow) result.setText("Match nul");
    else {
      if (playerThrow == 0) {
	if (compThrow == 1) perd();
	else gagne();
      } 
      else if (playerThrow == 1) {
	if (compThrow == 0) gagne();
	else perd();
      } else {
	if (compThrow == 0) perd();
	else gagne();
      }
    }
  }

  public String getAppletInfo() {
    return "Rochambeaux simulator by Jamie M. Hall, 1995";
  }

}

