import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class ListeFic extends Frame 
 implements WindowListener,ActionListener,ItemListener {

 File dossierCourant=new File(".");
 List dossiers=new List();
 List fichiers=new List();
 TextField chemin=new TextField();
 Label infoFichier=new Label();
 
 public ListeFic() {
  addWindowListener(this);  
  Panel p1=new Panel();
  add(BorderLayout.NORTH,p1);
  p1.setLayout(new GridLayout(2,2));
  p1.add(new Label("Dossier courant :"));
  p1.add(chemin);
  chemin.setEditable(false);
  p1.add(new Label("Sous Dossiers"));
  p1.add(new Label("Fichiers"));
  Panel p2=new Panel();
  add(BorderLayout.CENTER,p2);
  p2.setLayout(new GridLayout(1,2));
  p2.add(dossiers);
  p2.add(fichiers);
  add(BorderLayout.SOUTH,infoFichier);
  pack();
  setBounds(50,50,400,300);
  dossiers.addActionListener(this);
  fichiers.addItemListener(this);
  lireDossier();
 }
 
 void lireDossier() {
  String[] contenu=dossierCourant.list();
  dossiers.removeAll();
  dossiers.addItem("..");
  fichiers.removeAll();
  for (int i=0; i<contenu.length; i++) {
   File f=new File(dossierCourant,contenu[i]);
   if (f.isDirectory()) dossiers.addItem(contenu[i]);
   else fichiers.addItem(contenu[i]);
  }
  try {
   chemin.setText(dossierCourant.getCanonicalPath());
  } catch (Exception e) {
   chemin.setText("");
  } 
  if (fichiers.getItemCount()>0) {
   fichiers.select(0);
   ecrireInfoFichier();
  }
  dossiers.select(0);
 }

 void ecrireInfoFichier() {
  String nom=fichiers.getSelectedItem();
  File f=new File(dossierCourant,nom);
  infoFichier.setText("Fichier "+nom+"  ("+f.length()+")");
 }
 
 /**
  * Changement de rpertoire par slection dans la liste
  */
 public void actionPerformed(ActionEvent e) {
  if (e.getSource()==dossiers) {
   dossierCourant=new File(dossierCourant,dossiers.getSelectedItem());
   lireDossier();
  } 
 }
 
 public void itemStateChanged(ItemEvent e) {
  if (e.getStateChange()==ItemEvent.SELECTED) {
   if (fichiers.getItemCount()>0) ecrireInfoFichier();
  }
 }
 
 /**
  * Gestion de l'vnement Case de fermeture
  */
 public void windowClosing(WindowEvent event) {
  System.exit(0);
 }

 public void windowClosed(WindowEvent event) {}

 public void windowDeiconified(WindowEvent event) {}

 public void windowIconified(WindowEvent event) {}

 public void windowActivated(WindowEvent event) {}

 public void windowDeactivated(WindowEvent event) {}

 public void windowOpened(WindowEvent event) {}

 public static void main(String args[]) {
  System.out.println("Chargement en cours...");
  ListeFic fr=new ListeFic();
  fr.setTitle("Liste de fichiers");
  fr.setVisible(true);
 }
}

