import java.awt.*;

public class CanvasImage extends Canvas {

 Image img[];
 int num;
 
 public CanvasImage() {
  img=null;
  num=-1;
  setBackground(Color.lightGray);
  setForeground(Color.lightGray);
 }
 
 public void update(Graphics g) {
  if (num>=0 && img!=null) paint(g);
  else super.update(g);
 }
 
 public void paint(Graphics g) {
  g.draw3DRect(0,0,getSize().width-1,getSize().height-1,true); 
  if (num>=0 && img!=null)
   g.drawImage(img[num],2,2,getSize().width-4, getSize().height-4,this); 
 }

 public void tireImage() {
  double d=Math.random();
  if (d<0.1) num=0;
  else if (d<0.4) num=1;
  else if (d<0.7) num=2;
  else num=3;
  repaint();
 }
 
 public void setImage(int n) {
  num=n;
  repaint();
 }
 
 public void nextImage() {
  if (img!=null) {
   num++;
   if (num>=img.length) num=0;
   repaint();
  }
 }
 
 public int getImageNum() {
  return num;
 }
 
}

