/*
 * A simple slot machine game.
 * 
 * Feel free to re-use any part of this code.
 *
 * Jamie M. Hall, jamihall@mhv.net 1/9/96
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class Slot extends Applet implements ActionListener {

 CanvasImage gauche=new CanvasImage();
 CanvasImage centre=new CanvasImage();
 CanvasImage droite=new CanvasImage();
 AudioClip gain; 
 
 Label scoreLabel;
 int score;
 Button spin;
 
 public void init() {
  int i;
  Panel p, q;

  setFont(new Font("SansSerif", Font.BOLD, 16));
  setBackground(Color.lightGray);
  setLayout(new BorderLayout(8,8));

  //tlchargement des images
  Image[] tableImages=new Image[4];
  MediaTracker tracker=new MediaTracker(this);
  for (i=0; i<4; i++) {
   tableImages[i]=getImage(getCodeBase(),"T"+Integer.toString(i+1)+".gif");
   tracker.addImage(tableImages[i],i);
  } 
  try {
   tracker.waitForID(3);
  } catch (InterruptedException e) {}
  gauche.img=tableImages;
  centre.img=tableImages;
  droite.img=tableImages;
  //Son
  gain=getAudioClip(getCodeBase(), "ding.au");
  //Label titre
  p=new Panel();
  add(BorderLayout.NORTH, p);
  Label l=new Label("Machine  sous");
  p.add(l);
  l.setForeground(Color.blue);
  l.setFont(new Font("SansSerif",Font.BOLD+Font.ITALIC,20));
  //les 3 images  
  p=new Panel();
  add(BorderLayout.CENTER,p);
  p.setLayout(new GridLayout(1,3,16,0));
  p.add(gauche);
  p.add(centre);
  p.add(droite);
  add(BorderLayout.CENTER,p);
  //bouton et score
  p=new Panel();
  add(BorderLayout.SOUTH,p);
  p.setLayout(new GridLayout(2,1));
  q=new Panel();
  p.add(q);
  spin = new Button("Payer 10 dollars !");
  q.add(spin);
  spin.addActionListener(this);
  spin.setBackground(Color.blue);
    
  q=new Panel();
  p.add(q);
  score=0;
  scoreLabel=new Label("Total = 00  ");
  q.add(scoreLabel);
  scoreLabel.setForeground(Color.red);
 }

 void ajoute(int points) {
  score=score+points;
  scoreLabel.setText("Total = "+score);
  if (points>0) {
   showStatus("Vous gagnez "+points+" $ - BRAVO!");
   gain.play();
  }
  else showStatus("Dsol, vous perdez !");
 }
 
 public void actionPerformed(ActionEvent evt) {
  if (evt.getSource()==spin) {
   if (score==0) newGame();
   else doSpin();
  } 
 }

 public void newGame() {
  gauche.setImage(0);
  centre.setImage(0);
  droite.setImage(0);
  showStatus("Merci...");
  spin.setLabel("   JEU   ");
  score=10;
  scoreLabel.setText("Total = "+score);
 }

 public void doSpin() {
  gauche.tireImage();
  centre.tireImage();
  droite.tireImage();
  marqueScore();
 }
 
 public void marqueScore() {
  int special=0;
  if (gauche.getImageNum()==0) special++;
  if (centre.getImageNum()==0) special++;
  if (droite.getImageNum()==0) special++;
  if (special==3) ajoute(100);
  else if (special==2) ajoute(25);
  else if (gauche.getImageNum()==centre.getImageNum() && 
    gauche.getImageNum()==droite.getImageNum()) ajoute(5);
  else ajoute(-1);
  if (score==0) spin.setLabel("Payer 10 dollars !"); 
 }

 public Insets getInsets() {
  return new Insets(12,12,12,12);
 }

 public void paint(Graphics g) {
  g.setColor(Color.lightGray);
  g.draw3DRect(0,0,getSize().width-1,getSize().height-1,true); 
  g.draw3DRect(4,4,getSize().width-9,getSize().height-9,false); 
 }
  
}


