import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class CliHeure extends Frame 
 implements Runnable, ActionListener {

 int portServeur;
 String adresseServeur;
 Thread processus=null;
 Label heure=new Label("Connexion au serveur d'heure");
 Socket sk;
 BufferedReader depuisServeur;
 PrintWriter versServeur;

 public CliHeure(String adresse, int port) {
  portServeur=port;
  adresseServeur=adresse;
  addWindowListener(new Fermeture()); 
  Panel p=new Panel();
  p.setBackground(Color.white);
  add(BorderLayout.CENTER,p);
  p.setLayout(new GridLayout(2,1));
  p.add(heure);
  heure.setAlignment(Label.CENTER);
  Panel p1=new Panel();
  p.add(p1);
  Button b=new Button("Heure");
  p1.add(b);
  b.addActionListener(this);
  pack();
  processus=new Thread(this);
  processus.start();
 }
    
 public void run() {
  boolean fini=false;
  try {
   connect();
   String ligne;
   while (!fini) {
    ligne=depuisServeur.readLine();
    if (ligne==null) fini=true;
    else if (ligne.startsWith("Au revoir")) fini=true;
    else if (ligne.startsWith("Il est")) heure.setText(ligne);
   }
  } catch (IOException e) {
   heure.setText("Connexion impossible.");
  } finally {
   processus=null;
  }
 } 

 public void connect() {
  try {
   sk=new Socket(adresseServeur,portServeur);
   depuisServeur=new BufferedReader(
    new InputStreamReader(sk.getInputStream()));
   versServeur=new PrintWriter(
    new OutputStreamWriter(sk.getOutputStream()),true);
   //demander l'heure
   versServeur.println("h");
  } catch (Exception e) {
   heure.setText(e.toString());
  } 
 }

 public void disconnect() {
  try {
   sk.close();
  } catch (IOException e) {
  }
 } 

 public void actionPerformed(ActionEvent e) {
  if (e.getActionCommand().equals("Heure")) versServeur.println("h");
 }
 
 class Fermeture extends WindowAdapter {
  /**
   * Gestion de l'vnement Case de fermeture
   */
  public void windowClosing(WindowEvent e) {
   versServeur.println("");
   disconnect();
   System.exit(0);
  }
 }

 public static void main(String args[]) {
  System.out.println("Chargement en cours...");
  CliHeure cli=new CliHeure("localhost",1234);
  cli.setTitle("Heure");
  cli.setVisible(true);
 }

}

