import java.io.*;
import java.net.*;
import java.util.*;

public class ServHeure {

 static int port;

 public static void main(String args[]) {
  ServerSocket serveur;
  //dfinition du port
  try {
   port=Integer.parseInt(args[0]);
  } catch (Exception e) {
   port=1234;  //valeur par dfaut
  }
  //installation
  try {
   serveur=new ServerSocket(port);
   System.out.println("Serveur d'heures OK.");
   while (true) {
    //cration de nouvelles connexions
    Socket s=serveur.accept();
    new MaConnexion(s);
   } 
  } catch (IOException e) {
   System.out.println("Erreur  la creation d'un objet Socket : "+e.getMessage());
   System.exit(1);
  }
 }
}

/**
 * La classe MaConnexion cre un processus de dialogue avec le client
 */
class MaConnexion implements Runnable {
 Socket client;               //liaison avec client
 BufferedReader depuisClient; //rception de requte
 PrintWriter versClient;      //envoi des rponses
 
 //Constructeur
 public MaConnexion(Socket client) {
  this.client=client;
  try {
   // cration des flots de/vers le client
   depuisClient=new BufferedReader(new InputStreamReader(client.getInputStream())); 
   versClient=new PrintWriter(new OutputStreamWriter(client.getOutputStream()),true);
   // message d'accueil
   versClient.println("Bienvenue sur le serveur d'heure.");
   versClient.println("Entrez h pour obtenir l'heure.");
   versClient.println("Envoyez une chane vide pour fermer la connexion.");
  } catch (IOException e) {
   try { 
   client.close(); 
   } catch (IOException ee) {}
  }
  //mise en route du processus par appel de la mthode run
  new Thread(this).start();
 }

 //processus de dialogue
 public void run() {
  boolean fini=false;
  try {
   String lue;  //la requte
   String rep;  //la rponse
   while (!fini) {
    lue=depuisClient.readLine();
    if (lue==null) fini=true;
    else if (!lue.equals("h")) fini=true;
    else {
     //on envoie l'heure
     Calendar cal=Calendar.getInstance();
     rep="Il est "+cal.get(Calendar.HOUR)+"h"
        +cal.get(Calendar.MINUTE)+"mn"+cal.get(Calendar.SECOND)+"s.";
     versClient.println(rep);
    }
   }
  } catch (IOException e) {
   System.out.println("Exception entre/sortie : "+e.getMessage());
  } 
  //fermeture de la connexion
  stop();
 }
    
 public void stop() {
  try {
   versClient.println("Au revoir !");
   client.close();
  } catch (IOException e) {
   System.out.println("Exception  la fermeture d'une connexion : "+e);
  }
 }
    
}

