// Pour utiliser TelServeur :
//  partir d'une console DOS
// java TelServeur 1234
// le serveur est en route, il faut revenir  la console
// et taper Ctrl-C pour l'arrter
// On peut entrer en relation avec le serveur par telnet
// en indiquant serveur localhost et port 1234
// (penser  bien configurer telnet pour qu'il renvoie
// l'cho des entres-clavier)
//
/*
 * Serveur multi-clients
 * Renvoie de numro de tlphone
 */

import java.io.*;
import java.net.*;
import java.util.*;

public class TelServeur {

 static int port;
 
 public static void main(String args[]) {
  ServerSocket serveur;
  //dfinition du port
  try {
   port=Integer.parseInt(args[0]);
  } catch (Exception e) {
   port=1234;
  }
  //chargement des donnes
  Vector datas=new Vector();
  String ligne;
  try {
   BufferedReader br=new BufferedReader(new FileReader("telefon.txt")); 
   while (null!=(ligne = br.readLine()))
    if (ligne.indexOf('=')>0) datas.addElement(ligne);
   br.close();                
  } catch (Exception e) {
   System.out.println("Erreur de lecture du fichier.");
  }
  //installation
  try {
   serveur=new ServerSocket(port);
   while (true)
    //cration de nouvelles connexions
    new connexion(serveur.accept(),datas);
   } catch (IOException e) {
   System.out.println("Erreur  la creation d'un objet Socket : "+e.getMessage());
   System.exit(1);
  }
 }

}

//classe grant les connexions
class connexion implements Runnable {
 Socket client;
 BufferedReader depuisClient;
 PrintWriter versClient;
 Vector datas;
    
 public connexion(Socket client, Vector d) {
  this.client=client;
  datas=d;
  try {
   // creation des flux de/vers le client
   depuisClient=new BufferedReader(new InputStreamReader(client.getInputStream())); 
   versClient=new PrintWriter(new OutputStreamWriter(client.getOutputStream()),true);
   // message d'accueil
   versClient.println("Bienvenue sur le serveur de numros de tlphone.");
  } catch (IOException e) {
   try { 
   client.close(); 
   } catch (IOException ee) {}
  }
  new Thread(this).start();
 }

 String reponse(String demande) {
  String rep="inconnu";
  int i=0;
  while (i<datas.size() && rep.equals("inconnu")) {
   String S=(String)datas.elementAt(i);
   StringTokenizer st=new StringTokenizer(S,"=");
   if (demande.equals(st.nextToken())) rep=st.nextToken();
   i++;
  } 
  return rep;
 }
 
 public void run() {
  try {
   String lue;
   while ((lue=depuisClient.readLine())!=null) {
    if (lue.length()>0) {
     versClient.println(reponse(lue));
    }
   }
  } catch (IOException e) {
   System.out.println("Exception entre/sortie : "+e.getMessage());
  } 
  stop();
 }
    
 public void stop() {
  try {
   versClient.println("Au revoir !");
   client.close();
  } catch (IOException e) {
   System.out.println("Exception  la fermeture d'une connexion : "+e);
  }
 }
    
}

