import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.*;

/*
 * JPanel contenant un cercle
 */
class DisquePanel extends JPanel {

 int diametre=50;
 Color clr=Color.red;
 
 /*
  * constructeur
  */
 DisquePanel() {
  setPreferredSize(new Dimension(130,130));
 }
		
 /*
  * affichage
  */
 public void paint(Graphics g) {
  g.setColor(clr);
  g.fillOval(65-diametre/2,65-diametre/2,diametre, diametre);
 }
 
 /*
  * changement de diamtre
  */
 public void setDiametre(int d) {
  diametre=d;
 } 
}

class SliderF extends JFrame 
 implements ChangeListener, ActionListener {

 JSlider js;	                   //composant swing pour diamtre
 DisquePanel dp;                   //dessin du cercle
 JButton changeLAF;                //bouton changement de style
 UIManager.LookAndFeelInfo laf[];  //styles disponibles
 int lafNo=0;                      //numro style courant
 JLabel nomStyle;                  //nom du style utilis
	
 /*
  * initialisation
  */
 public void init() {
  setTitle("Cercle");
  addWindowListener(new Ferme());
  //chargement des styles disponibles
  laf=UIManager.getInstalledLookAndFeels();
  
  //****************JPanel principal ajout  la fentre
  JPanel p=new JPanel();
  getContentPane().add(p);
  //gestionnaire de positionnement : alignement vertical
  BoxLayout bxl=new BoxLayout(p,BoxLayout.Y_AXIS);
  p.setLayout(bxl);
  
  //****************nom du style
  nomStyle=new JLabel("LAF: "+UIManager.getLookAndFeel().getName());
  p.add(nomStyle);
  //utilisation d'une bordure
  nomStyle.setBorder(BorderFactory.createMatteBorder(
                     5, 8, 5, 8, Color.orange));
  
  //****************le slider
  js=new JSlider(0,120,40);
  p.add(js);
  js.setMajorTickSpacing(30);
  js.setMinorTickSpacing(5);
  js.setPaintTicks(true);
  //couteur
  js.addChangeListener(this);
	
  //*****************dessin
  JPanel pi=new JPanel();
  p.add(pi);
  dp=new DisquePanel();
  pi.add(dp, BorderLayout.CENTER);
  pi.setBorder(BorderFactory.createEtchedBorder());
  
  //*********************bouton de changement
  changeLAF=new JButton("Change");
  p.add(changeLAF);
  //couteur
  changeLAF.addActionListener(this);
		
  //taille et affichage
  setSize(300,250);
  setVisible(true);
 }
	
 /*
  * couter les changements du slider
  */
 public void stateChanged(ChangeEvent e) {
  if (e.getSource()==js) dp.setDiametre(js.getValue());
  repaint();
 }

 /*
  * couter bouton change
  */
 public void actionPerformed(ActionEvent e) {
  //on passe au numro de style suivant ou 0
  lafNo=(lafNo+1) % laf.length;
  //on essaie d'effectuer le changement
  try {
   UIManager.setLookAndFeel(laf[lafNo].getClassName());
   SwingUtilities.updateComponentTreeUI(this);
   nomStyle.setText("LAF: "+UIManager.getLookAndFeel().getName());
  } catch (Exception exc) {}
  repaint();
 }

}

/*
 * couteur pour la fentre
 */
class Ferme extends WindowAdapter {
 public void windowClosing(WindowEvent e) {
  System.exit(0);
 }
}

/*
 * classe principale lanant le programme
 */
public class SF {
 public static void main(String[] args) {
  SliderF sf=new SliderF();
  sf.init();
 }
 
}

