import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * classe reprsentant un JPanel contenant un tableau dont les 
 * donnes se trouvent dans un fichier csv 
 * - texte, un enregistrement par ligne
 * - champs spars par des virgules,
 * - la premire ligne donne les noms des champs
 */
public class DataFileTable extends JPanel {

 DataFileTableModel model;    // le modle de remplissage
 TableCloser tc;
 
 /**
  * constructeur : le nom du fichier de donnes est pass en
  * paramtre
  */
 public DataFileTable(String dataFilePath) {
  tc=new TableCloser();
  JTable table;                // le tableau
  //fonte
  Font f=new Font("SanSerif",Font.PLAIN,24);
  setFont(f);
  //gestionnaire de positionnement
  setLayout(new BorderLayout());
  //construction du modle de remplissage  partir du fichier
  model = new DataFileTableModel(dataFilePath);
  //cration du tableau
  table=new JTable();
  table.setModel(model);
  table.createDefaultColumnsFromModel();
  //scroller
  JScrollPane scrollpane=new JScrollPane(table);
  add(scrollpane);
 }

 /**
  * dimensions du tableau
  */
 public Dimension getPreferredSize() {
  return new Dimension(400, 300);
 }

 /**
  * mthode principale du programme
  * cration et affichage de la fentre
  */
 public static void main(String args[]) {
  //la fentre du programme
  JFrame fen=new JFrame("Table");
  //le tableau
  DataFileTable tablo;
  String nomFichier="datas.txt";
  if (args.length>0) nomFichier=args[0];
  tablo=new DataFileTable(nomFichier);
  //configuration de la fentre
  fen.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
  fen.setForeground(Color.black);
  fen.setBackground(Color.lightGray);
  fen.getContentPane().add(tablo,"Center");
  fen.setSize(tablo.getPreferredSize());
  //affichage
  fen.setVisible(true);
  //couteur pour fermeture
  fen.addWindowListener(tablo.tc);
 }

 /**
  * classe grant la fermeture de la fentre
  */
 class TableCloser extends WindowAdapter {

  public void windowClosing(WindowEvent e) {
   model.saveVectors();
   Window win=e.getWindow();
   //effacer la fentre
   win.setVisible(false);
   //terminer le programme
   System.exit(0);
  }
 
 }

}


